{******************************************************************************}
{* This code was written by : Jamie Hart                                      *}
{******************************************************************************}
{* This unit is part of the example program for the xBase component, a        *}
{* NON-EDI way of accessing dBase III+ data files.                            *}
{*                                                                            *}
{* The component is freeware: any comments or suggestions are welcome at:     *}
{* jay@bitsmart.com                                                           *}
{******************************************************************************}

unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, XBase, ExtCtrls, Buttons;

type
  TForm1 = class(TForm)
    SpeedButton1: TSpeedButton;
    SpeedButton2: TSpeedButton;
    SpeedButton3: TSpeedButton;
    SpeedButton4: TSpeedButton;
    SpeedButton5: TSpeedButton;
    SpeedButton6: TSpeedButton;
    Panel1: TPanel;
    Label1: TLabel;
    Name: TEdit;
    Label2: TLabel;
    Phone: TEdit;
    Label3: TLabel;
    Email: TEdit;
    XBase1: TXBase;
    Label4: TLabel;
    Notes: TMemo;
    SpeedButton7: TSpeedButton;
    SpeedButton8: TSpeedButton;
    procedure SpeedButton7Click(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
    procedure SpeedButton2Click(Sender: TObject);
    procedure SpeedButton3Click(Sender: TObject);
    procedure SpeedButton4Click(Sender: TObject);
    procedure SpeedButton5Click(Sender: TObject);
    procedure SpeedButton6Click(Sender: TObject);
    procedure SpeedButton8Click(Sender: TObject);
    procedure XBase1Changing(Sender: TObject; var Allowed: Boolean);
    procedure XBase1Deleting(Sender: TObject; var Allowed: Boolean);
    procedure XBase1Appended(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure PhoneExit(Sender: TObject);
    procedure EmailExit(Sender: TObject);
    procedure NotesExit(Sender: TObject);
    procedure NameEnter(Sender: TObject);
    procedure PhoneEnter(Sender: TObject);
    procedure EmailEnter(Sender: TObject);
    procedure NotesEnter(Sender: TObject);
    procedure NameExit(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
  private
    { Private declarations }
    OldText: String;
    Procedure UpdateFields;
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

Procedure TForm1.UpdateFields;
begin
  Name.Text := XBase1.GetFieldByName('Name');
  Phone.Text := XBase1.GetFieldByName('Phone');
  Email.Text := XBase1.GetFieldByName('Email');
  Notes.Text := XBase1.GetFieldByName('Notes');
end;

procedure TForm1.SpeedButton7Click(Sender: TObject);
begin
  XBase1.AppendBlank;
end;

procedure TForm1.SpeedButton1Click(Sender: TObject);
begin
  XBase1.GotoBof;
  UpdateFields;
end;

procedure TForm1.SpeedButton2Click(Sender: TObject);
begin
  XBase1.GotoPrev;
  UpdateFields;
end;

procedure TForm1.SpeedButton3Click(Sender: TObject);
begin
  XBase1.GotoNext;
  UpdateFields;
end;

procedure TForm1.SpeedButton4Click(Sender: TObject);
begin
  XBase1.GotoEof;
  UpdateFields;
end;

procedure TForm1.SpeedButton5Click(Sender: TObject);
begin
  XBase1.PostChanges;
end;

procedure TForm1.SpeedButton6Click(Sender: TObject);
begin
  XBase1.RefreshRecord;
  UpdateFields;
end;

procedure TForm1.SpeedButton8Click(Sender: TObject);
begin
  XBase1.Active := False;
  Application.Terminate;
end;

procedure TForm1.XBase1Changing(Sender: TObject; var Allowed: Boolean);
begin
  if XBase1.Modified then begin
    if Application.MessageBox('Do You want to save the changes','Record has Changed',MB_ICONSTOP+MB_YESNO) = IDYES then begin
      XBase1.PostChanges; {Save Changes}
    end;
  end
end;

procedure TForm1.XBase1Deleting(Sender: TObject; var Allowed: Boolean);
begin
  if Application.MessageBox('Are You Sure?','Delete Record',MB_ICONSTOP+MB_YESNO) = IDYES then begin
    Allowed := True; {Allow Delete}
  end else begin
    Allowed := False; {Dont Delete}
  end;
end;

procedure TForm1.XBase1Appended(Sender: TObject);
begin
  XBase1.GotoEof;
  UpdateFields;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  if fileexists('Address.dbf') then begin
    XBase1.FileName := 'Address';
    XBase1.Active := True;
    UpdateFields;
  end else begin
    Application.MessageBox('Data file does not exist!','Cannot Continue',MB_ICONSTOP+MB_OK);
    Application.Terminate;
  end;
end;

{******************************************************************************}
{* The following routines are used to check whether a change has been made to *}
{* to the current Field (TEdit)                                               *}
{******************************************************************************}
procedure TForm1.NameEnter(Sender: TObject);
begin
  OldText := Name.Text;
end;

procedure TForm1.NameExit(Sender: TObject);
begin
  if Name.Text <> OldText then begin
    XBase1.PutFieldByName('Name',Copy(Name.Text,1,30));
  end;
end;

procedure TForm1.PhoneEnter(Sender: TObject);
begin
  OldText := Phone.Text;
end;

procedure TForm1.PhoneExit(Sender: TObject);
begin
  if Phone.Text <> OldText then begin
    XBase1.PutFieldByName('Phone',Copy(Phone.Text,1,30));
  end;
end;

procedure TForm1.EmailEnter(Sender: TObject);
begin
  OldText := Email.Text;
end;

procedure TForm1.EmailExit(Sender: TObject);
begin
  if Email.Text <> OldText then begin
    XBase1.PutFieldByName('Email',Copy(Email.Text,1,30));
  end;
end;

procedure TForm1.NotesEnter(Sender: TObject);
begin
  OldText := Notes.Text;
end;

procedure TForm1.NotesExit(Sender: TObject);
begin
  if Notes.Text <> OldText then begin
    XBase1.PutFieldByName('Notes',Notes.Text);
  end;
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
  XBase1.Active := False;
end;

end.
